globals[
  itermed
  dist2med
]

turtles-own [ 
  dist
  iter
]

patches-own [
  remover?
]

to preparar
  clear-all
  set itermed 0
  crt ntartarugas 
  ask turtles [
    setxy 0 0
    set dist 0
    set iter 0
    pd
    set heading 0
    set shape "bee"
    set size 15
  ]
  if limite? [
    ask patches[
      if (int (distancexy 0 0) = raio-limite)
       [ set pcolor 3 ]
    ] 
  ]
  reset-ticks
end

to executar
  if count turtles = 0 [
    show (word "Número de iterações médio: " itermed)
    stop
  ]
    
  set dist2med 0
  ask turtles [               
    rt 90 * (random 4)
    fd passos
      
    set dist sqrt (xcor * xcor + ycor * ycor)
    set dist2med dist2med + dist * dist
      
    if limite? and dist >= raio-limite [
      set itermed itermed + iter / ntartarugas
      die
    ]
    set iter iter + 1
  ]
  set dist2med dist2med / ntartarugas
  
  if count turtles = ntartarugas [
    plot-dist2med dist2med
  ]
  tick
end

to plot-dist2med [ d2med ]
  set-current-plot "Distância Quadrática Média"
  plot d2med
end

to selec-fronteira
  if passos != 1 [
    user-message "Para efectuar esta operação deve escolher passo = 1"
    stop
  ]
  
  if limite? [
    ask patches[
      if (int (distancexy 0 0) = raio-limite)
      [ set pcolor black ]
    ] 
  ]
  ask patches [ set remover? false ]
  ask patches with [ pcolor != black ][
    verif-fronteira
  ]
  
  ask patches with [ remover? ] [
    set pcolor black
  ]
end

to verif-fronteira
  let remc 0
  
  
  set remc 0
  ask patches at-points [ [1 0] [0 1] [-1 0] [0 -1] ] [
    if pcolor != black [
      set remc remc + 1
    ]
  ]
  if remc = 4 [
    set remover? true
  ]
end

;exporta o mundo (escreve o valor de todas as variáveis)
;para um ficheiro de nome nomeficheiro 
to exportarmundo
 let nomeficheiro 0
  let ax 0
  let ay 0
  

 set nomeficheiro user-new-file

 if file-exists? nomeficheiro [
   file-delete nomeficheiro
 ]

 file-open nomeficheiro
 file-print world-width
 file-print world-height
 
 show (word "sx: " world-width "  sy: " world-height)
 set ay min-pycor
 repeat world-height
 [
   set ax min-pxcor
   repeat world-width
   [
     ask patch ax ay [
       file-print pcolor
     ]
     set ax ax + 1
   ]
   set ay ay + 1
 ]
 file-close
end

; Versão ICES Copyright 2004, Centro de Física Teórica e Computacional
@#$#@#$#@
GRAPHICS-WINDOW
458
10
981
554
256
256
1.0
1
10
1
1
1
0
1
1
1
-256
256
-256
256
0
0
1
iterações
30.0

BUTTON
255
67
364
100
NIL
executar
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
20
27
192
60
passos
passos
1
10
1
1
1
NIL
HORIZONTAL

BUTTON
254
27
364
60
NIL
preparar
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
20
66
192
99
ntartarugas
ntartarugas
1
100
1
1
1
NIL
HORIZONTAL

BUTTON
458
557
596
590
Exportar Mundo
exportarmundo
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
137
119
309
152
raio-limite
raio-limite
0
256
256
1
1
NIL
HORIZONTAL

SWITCH
21
119
124
152
limite?
limite?
0
1
-1000

PLOT
33
173
422
481
Distância Quadrática Média
Iteração
Distância**2
0.0
100.0
0.0
100.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

BUTTON
655
557
824
590
Seleccionar Fronteira
selec-fronteira
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

@#$#@#$#@
INTRODUÇÃO

Matematicamente, a marcha aleatória traduz a ideia de uma trajectória composta por passos consecutivos, cada um dado numa direcção aleatória.

A marcha aleatória é um processo estocástico simples com aplicações em campos muito diversos, que vão desde:

a física,   
modelizando o movimento aleatório de partículas microscópicas imersas num fluido composto por moléculas muito mais pequenas - fenómeno conhecido como movimento browniano;

à economia,  
o exemplo simples do jogo da moeda ao ar pode ser visto como a marcha aleatória num espaço a 1 dimensão;

passando pela biologia,   
propagação de estímulos dentro do cérebro; etc.

Neste programa, pretende-se estudar a marcha aleatória numa rede regular bidimensional. Partindo de um ponto inicial, cada passo tem um comprimento constante lp, e só 4 direcções aleatórias - norte, sul, este e oeste são permitidas.

Uma das características principais da marcha aleatória vai ser aqui colocada em evidência. Em média, o número de passos necessários para que a trajectória atinja uma circunferencia de raio r (a partir do seu centro) é

N=(r/lp)^2		(1).

Esta relação está também presente nos fenómenos de difusão de partículas em fluidos, se admitirmos que N é proporcional ao tempo decorrido. A título de curiosidade podemos mencionar que Eistein (no ano milagroso de 1905) utilizou a teoria cinética de fluidos para calcular a constante de proporcionalidade entre o tempo e a distância quadrática percorrida, em termos de constantes fundamentais das partículas e do fluido. Pouco mais tarde, a relação de Einstein permitiu a Perrin determinar experimentalmente o número de Avogadro.

A relação (1) é indicativa que a trajectória percorrida, apesar da sua forma complexa, tem na verdade dimensão 2 - a dimensão de uma área. No entanto, o número de pontos da fronteira da mesma trajectória são em média proporcionais a r^(4/3), um facto previsto por Mandelbrot através de simulações numéricas e provado rigorosamente apenas em 2001.

Neste programa, poder-se-á visualizar a complexidade da fronteira da trajectória da marcha aleatória numa rede regular bidimensional, que tal como os fractais geométricos e os atractores estranhos, exibem uma estrutura não trivial em escalas cada vez mais pequenas, e com uma dimensão fractal não inteira.

UTILIZAÇÃO

Para inicializar o programa de marcha aleatória, deve em primeiro lugar seleccionar o número de turtles ("ntartarugas") que vão executar as trajectórias, todas a partir do mesmo ponto central inicial.

Pode ainda seleccionar o comprimento do passo da rede bidimensional ("passos") da marcha aleatória.

Se quiser que as trajectórias parem ao atingir uma determinada circunferência limite, deve colocar o botão "limite?" em "on" e definir o raio da circunferência desejado ("raio-limite").

Caso contrário, se quiser que as trajectórias continuem indefinidamente, basta colocar o botão "limite?" em "off".

Depois de ter escolhido todos estes parâmetros, deve seleccionar "Preparar" e finalmente "Iniciar/Parar" para começar o procedimento da marcha aleatória.

No gráfico pode visualizar a distância (em relação ao ponto inicial central) quadrática média de todas as trajectórias (cujo número foi definido em ntartarugas) em função do número de passos ou iterações.

Se "limite?=on", cada uma das trajectórias é interrompida no momento em que atinge a circunferência limite. O gráfico da distância quadrática média deixa de ser actualizado assim que a primeira tartaruga é eliminada. Por fim, depois de todas as turtles terem sido eliminadas, o programa pára e o número médio de iterações necessário para atingir a circunferência é indicado automaticamente no "Command Center".

É possível visualizar a forma da fronteira da(s) trajectória(s) com o botão "Seleccionar Fronteira".

A imagem final pode ser gravada seleccionando "Exportar Mundo", e poderá ser analisada posteriormente no programa "calcula-dimensao.nlogo".

QUESTÕES

1. Escolha um pequeno número de turtles (cada uma desenhará uma trajectória diferente) e um grande raio limite. Observe a evolução da distância quadrática média no gráfico. Compare com a evolução esperada. Aumente o número de tartarugas e comente os novos resultados obtidos.

2. Qual seria a evolução esperada, não para a distância quadrática mas para a abcissa quadrática média das trajectórias, <x^2>?

3. Escolha um grande número de tartarugas e diferentes passos/raios-limite. Corra o procedimento de marcha aleatória até todas as tartarugas serem eliminadas. Qual é em média o número de iterações necessário para atingir a circunferência limite que espera encontrar ? Compare com o resultado obtido, indicado na janela "Command Center" assim que o programa termina.  
(Sugestão: para acelerar as trajectórias clique no botão "on/off" do ecrã de visualização - as trajectórias deixam de ser actualizadas no ecrã.)

4. Com "limite?=off", uma só tartaruga e passo=1, correspondente à resolução máxima do ecrã, corra o procedimento de marcha aleatória durante algum tempo, de modo a obter uma imagem razoavelmente preenchida. Comente a estrutura final obtida à luz dos conceitos introduzidos neste módulo "Fractais". Comente também a estrutura da fronteira da trajectória (utilize o botão "Seleccionar Fronteira").

5. Com base na questão anterior, estime a probabilidade que uma dada casa da rede tem de permanecer para sempre livre do percurso da marcha aleatória. Justifique.

VARIANTES E EXTENSÕES

Faça uma análise estatística mais detalhada da marcha aleatória, incluindo a observação da média das trajectórias, desvio padrão, etc.

Implemente e analise as extensões mais conhecidas da marcha aleatória:  
marcha aleatória sem auto-intersecção ("self avoiding random walk");  
marcha aleatória sem regresso ("no returning random walk");  
etc.

REFERÊNCIAS

http://mathworld.wolfram.com  
http://scienceworld.wolfram.com
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7500403 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7500403 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7500403 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7500403 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7500403 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7500403 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7500403 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7500403 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7500403 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -1184463 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7500403 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7500403 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7500403 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7500403 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7500403 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7500403 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7500403 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7500403 true 167 47 159 82
Line -7500403 true 136 47 145 81
Circle -7500403 true true 165 45 8
Circle -7500403 true true 134 45 6
Circle -7500403 true true 133 44 7
Circle -7500403 true true 133 43 8

circle
false
0
Circle -7500403 true true 35 35 230

person
false
0
Circle -7500403 true true 155 20 63
Rectangle -7500403 true true 158 79 217 164
Polygon -7500403 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7500403 true true 216 83 267 123 248 143 215 107
Polygon -7500403 true true 167 163 145 234 183 234 183 163
Polygon -7500403 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7500403 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7500403 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7500403 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8630108 true false 195 75 195 120 240 120 240 75
Polygon -8630108 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7500403 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8630108 true false 90 210 105 225 120 210
Polygon -8630108 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7500403 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8630108 true false 210 210 195 225 180 210
Polygon -8630108 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7500403 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7500403 true true 15 105 105 165
Rectangle -7500403 true true 45 90 105 105
Polygon -7500403 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7500403 true true 105 120 263 195
Rectangle -7500403 true true 108 195 259 201
Rectangle -7500403 true true 114 201 252 210
Rectangle -7500403 true true 120 210 243 214
Rectangle -7500403 true true 115 114 255 120
Rectangle -7500403 true true 128 108 248 114
Rectangle -7500403 true true 150 105 225 108
Rectangle -7500403 true true 132 214 155 270
Rectangle -7500403 true true 110 260 132 270
Rectangle -7500403 true true 210 214 232 270
Rectangle -7500403 true true 189 260 210 270
Line -7500403 true 263 127 281 155
Line -7500403 true 281 155 281 192

wolf-left
false
3
Polygon -6459832 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6459832 true true 87 80 79 55 76 79
Polygon -6459832 true true 81 75 70 58 73 82
Polygon -6459832 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6459832 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6459832 true true 116 140 114 189 105 137
Rectangle -6459832 true true 109 150 114 192
Rectangle -6459832 true true 111 143 116 191
Polygon -6459832 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6459832 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6459832 true true 214 134 203 168 192 148
Polygon -6459832 true true 204 151 203 176 193 148
Polygon -6459832 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6459832 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6459832 true true 201 99 214 69 215 99
Polygon -6459832 true true 207 98 223 71 220 101
Polygon -6459832 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6459832 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6459832 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6459832 true true 48 143 58 141
Polygon -6459832 true true 46 136 68 137
Polygon -6459832 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6459832 true true 38 138 66 149
Polygon -6459832 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6459832 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 5.0.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
